#ifndef EFL_GENERATED_EFL_TEXT_HH
#define EFL_GENERATED_EFL_TEXT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "efl_text.eo.h"
}

#include <string>

namespace efl {

struct text
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit text(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit text(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   text(text const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~text() {}

   /// @brief Retrieves the text string currently being displayed by the given
   /// text object.
   ///
   /// @return The text string currently being displayed on it.
   ///
   /// @note Do not free() the return value.
   ///
   /// @see evas_object_text_text_set()
   ///
   /// @param text Text string to display on it.
   ///
   std::string text_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::efl_text_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Sets the text string to be displayed by the given text object.
   ///
   /// @see evas_object_text_text_get()
   ///
   /// @param text Text string to display on it.
   ///
   void text_set(std::string text_) const
   {
      eo_do(_eo_ptr(), ::efl_text_set(efl::eolian::to_c(text_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(EFL_TEXT_INTERFACE);
   }

private:
};
} 

template <typename T>
std::string efl_text_text_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->text_get();
}

template <typename T>
void efl_text_text_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * text_)
{
   static_cast<T*>(self->this_)->text_set(efl::eolian::to_cxx<std::string>(text_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< efl::text >
{
   template <typename T>
   struct type
   {
      virtual std::string text_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_text_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void text_set(std::string text_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::efl_text_set(efl::eolian::to_c(text_)));
      }

   };
};


template<>
struct operation_description_class_size< efl::text >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<efl::text>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::efl_text_text_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::efl_text_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::efl_text_text_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::efl_text_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< efl::text >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<efl::text, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< efl::text>
{
   template <typename U>
   struct type
   {
      operator efl::text() const
      {
         return efl::text(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      std::string text_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::efl_text_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void text_set(std::string text_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::efl_text_set(efl::eolian::to_c(text_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<efl::text>)
{
   return (EFL_TEXT_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EFL_TEXT_HH

